## ros-one-ur-client-library 2.5.0-2jammy.20251029.2034

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14.0)


project(ur_client_library_tests)


include(FetchContent)
FetchContent_Declare(
  googletest
  GIT_REPOSITORY https://github.com/google/googletest.git
  GIT_TAG        v1.15.2
)
# For Windows: Prevent overriding the parent project's compiler/linker settings
set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
FetchContent_MakeAvailable(googletest)

include(GoogleTest)

option(INTEGRATION_TESTS "Build the integration tests that require a running robot / URSim" OFF)
# Build Tests
if (INTEGRATION_TESTS)
  # Integration tests require a robot reachable at 192.168.56.101. Therefore, they have to be
  # activated separately.
  
  find_package(Python3 COMPONENTS Interpreter REQUIRED)

  add_custom_target(generate_outputs ALL COMMAND ${Python3_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/resources/generate_rtde_outputs.py)
  add_executable(rtde_tests test_rtde_client.cpp)
  add_dependencies(rtde_tests generate_outputs)
  target_link_libraries(rtde_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
  gtest_add_tests(TARGET      rtde_tests
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )

  add_executable(dashboard_client_g5_tests test_dashboard_client_g5.cpp)
  target_link_libraries(dashboard_client_g5_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
  gtest_add_tests(TARGET      dashboard_client_g5_tests
  )

  add_executable(dashboard_client_x_tests test_dashboard_client_x.cpp)
  target_link_libraries(dashboard_client_x_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
  gtest_add_tests(TARGET      dashboard_client_x_tests
  )

  # Spline tests
  add_executable(spline_tests_urcap test_spline_interpolation.cpp)
  target_link_libraries(spline_tests_urcap PRIVATE ur_client_library::urcl GTest::gtest_main)
  gtest_add_tests(TARGET      spline_tests_urcap
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                  EXTRA_ARGS --headless false
                  TEST_SUFFIX _urcap
  )
  add_executable(spline_tests_headless test_spline_interpolation.cpp)
  target_link_libraries(spline_tests_headless PRIVATE ur_client_library::urcl GTest::gtest_main)
  gtest_add_tests(TARGET      spline_tests_headless
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                  EXTRA_ARGS --headless true
                  TEST_SUFFIX _headless
  )

  # UrDriver tests
  add_executable(ur_driver_tests_urcap test_ur_driver.cpp)
  target_link_libraries(ur_driver_tests_urcap PRIVATE ur_client_library::urcl GTest::gtest_main)
  gtest_add_tests(TARGET      ur_driver_tests_urcap
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                  EXTRA_ARGS --headless false
                  TEST_SUFFIX _urcap
  )
  add_executable(ur_driver_tests_headless test_ur_driver.cpp)
  target_link_libraries(ur_driver_tests_headless PRIVATE ur_client_library::urcl GTest::gtest_main)
  gtest_add_tests(TARGET      ur_driver_tests_headless
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                  EXTRA_ARGS --headless true
                  TEST_SUFFIX _headless
  )

  # InstructionExecutor tests
  add_executable(instruction_executor_test_urcap test_instruction_executor.cpp)
  target_link_libraries(instruction_executor_test_urcap PRIVATE ur_client_library::urcl GTest::gtest_main)
  gtest_add_tests(TARGET instruction_executor_test_urcap
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                  EXTRA_ARGS --headless false
                  TEST_SUFFIX _urcap
  )
  add_executable(instruction_executor_test_headless test_instruction_executor.cpp)
  target_link_libraries(instruction_executor_test_headless PRIVATE ur_client_library::urcl GTest::gtest_main)
  gtest_add_tests(TARGET instruction_executor_test_headless
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                  EXTRA_ARGS --headless true
                  TEST_SUFFIX _headless
  )

  # PrimaryClient tests
  add_executable(primary_client_test_urcap test_primary_client.cpp)
  target_link_libraries(primary_client_test_urcap PRIVATE ur_client_library::urcl GTest::gtest_main)
  gtest_add_tests(TARGET primary_client_test_urcap
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                  EXTRA_ARGS --headless false
                  TEST_SUFFIX _urcap
  )
  add_executable(primary_client_test_headless test_primary_client.cpp)
  target_link_libraries(primary_client_test_headless PRIVATE ur_client_library::urcl GTest::gtest_main)
  gtest_add_tests(TARGET primary_client_test_headless
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
                  EXTRA_ARGS --headless true
                  TEST_SUFFIX _headless
  )

  add_executable(ur_driver_deprecated_constructor_test test_deprecated_ur_driver_construction.cpp)
  target_link_libraries(ur_driver_deprecated_constructor_test PRIVATE ur_client_library::urcl GTest::gtest_main)
  gtest_add_tests(TARGET ur_driver_deprecated_constructor_test
                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
else()
  message(STATUS "Skipping integration tests.")
endif()


add_executable(dashboard_client_mock_tests test_dashboard_client.cpp)
target_link_libraries(dashboard_client_mock_tests PRIVATE ur_client_library::urcl GTest::gmock_main)
gtest_add_tests(TARGET      dashboard_client_mock_tests
)

add_executable(primary_parser_tests test_primary_parser.cpp)
target_link_libraries(primary_parser_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET      primary_parser_tests
)



add_executable(rtde_data_package_tests test_rtde_data_package.cpp)
target_link_libraries(rtde_data_package_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET      rtde_data_package_tests
)

add_executable(rtde_parser_tests test_rtde_parser.cpp)
target_link_libraries(rtde_parser_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET      rtde_parser_tests
)

add_executable(tcp_server_tests test_tcp_server.cpp)
target_link_libraries(tcp_server_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET      tcp_server_tests
)

add_executable(script_sender_tests test_script_sender.cpp)
target_link_libraries(script_sender_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET      script_sender_tests
)

add_executable(script_reader_tests test_script_reader.cpp)
target_link_libraries(script_reader_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(
        TARGET script_reader_tests
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

add_executable(reverse_interface_tests test_reverse_interface.cpp)
target_link_libraries(reverse_interface_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET reverse_interface_tests
)

add_executable(trajectory_point_interface_tests test_trajectory_point_interface.cpp)
target_link_libraries(trajectory_point_interface_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET trajectory_point_interface_tests
)

add_executable(rtde_control_package_pause_tests test_rtde_control_package_pause.cpp)
target_link_libraries(rtde_control_package_pause_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET rtde_control_package_pause_tests
)

add_executable(rtde_control_package_start_tests test_rtde_control_package_start.cpp)
target_link_libraries(rtde_control_package_start_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET rtde_control_package_start_tests
)

add_executable(rtde_control_package_setup_outputs_tests test_rtde_control_package_setup_outputs.cpp)
target_link_libraries(rtde_control_package_setup_outputs_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET rtde_control_package_setup_outputs_tests
)

add_executable(rtde_control_package_setup_inputs_tests test_rtde_control_package_setup_inputs.cpp)
target_link_libraries(rtde_control_package_setup_inputs_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET rtde_control_package_setup_inputs_tests
)

add_executable(rtde_get_urcontrol_version_tests test_rtde_get_urcontrol_version.cpp)
target_link_libraries(rtde_get_urcontrol_version_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET rtde_get_urcontrol_version_tests
)

add_executable(rtde_request_protocol_version_tests test_rtde_request_protocol_version.cpp)
target_link_libraries(rtde_request_protocol_version_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET rtde_request_protocol_version_tests
)

add_executable(rtde_writer_tests test_rtde_writer.cpp)
target_link_libraries(rtde_writer_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET rtde_writer_tests
)

add_executable(version_information_tests test_version_information.cpp)
target_link_libraries(version_information_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET version_information_tests
)

add_executable(bin_parser_tests test_bin_parser.cpp)
target_link_libraries(bin_parser_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET bin_parser_tests
)

add_executable(package_serializer_tests test_package_serializer.cpp)
target_link_libraries(package_serializer_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET package_serializer_tests
)

add_executable(tcp_socket_tests test_tcp_socket.cpp)
target_link_libraries(tcp_socket_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET tcp_socket_tests
)

add_executable(stream_tests test_stream.cpp)
target_link_libraries(stream_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET stream_tests
)

add_executable(producer_tests test_producer.cpp)
target_link_libraries(producer_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET producer_tests
)

add_executable(pipeline_tests test_pipeline.cpp)
target_link_libraries(pipeline_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET pipeline_tests
)

add_executable(script_command_interface_tests test_script_command_interface.cpp)
target_link_libraries(script_command_interface_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET script_command_interface_tests
)

add_executable(robot_receive_timeout_tests test_robot_receive_timeout.cpp)
target_link_libraries(robot_receive_timeout_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET robot_receive_timeout_tests
)

add_executable(control_mode_tests test_control_mode.cpp)
target_link_libraries(control_mode_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET control_mode_tests
)

add_executable(helpers_tests test_helpers.cpp)
target_link_libraries(helpers_tests PRIVATE ur_client_library::urcl GTest::gtest_main)
gtest_add_tests(TARGET helpers_tests
)

=== debian/changelog ===
ros-one-ur-client-library (2.5.0-2jammy.20251029.2034) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Felix Exner <feex@universal-robots.com>  Wed, 29 Oct 2025 20:34:02 +0000

ros-one-ur-client-library (2.5.0-0jammy) jammy; urgency=high

  * Polyscopex dashboard client (#392 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/392>)
  * Use enable_external_ft_sensor on old software versions (#395 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/395>)
  * Rtde external ft (#388 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/388>)
  * Fixed auto reconnection to the RTDE server. (#384 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/384>)
  * Refactor Rtde client test (#389 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/389>)
  * Add release.yml for auto-generated changelogs (#391 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/391>)
  * Allow an empty input recipe to the RTDE client (#318 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/318>)
  * Contributors: Felix Exner, Mads Holm Peters, URJala

 -- Felix Exner <feex@universal-robots.com>  Fri, 24 Oct 2025 00:00:00 -0000

ros-one-ur-client-library (2.4.0-0jammy) jammy; urgency=high

  * UR18 support (#387 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/387>)
  * Remove output_bit_register_0...63 and input_bit_register_0..63 from RTDE list (#385 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/385>)
  * Set force mode parameters from config (#383 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/383>)
  * Direct torque control (#381 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/381>)
  * Update RTDE list to include new fields (#380 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/380>)
  * Add const qualifier to get functions and changed map value retrieval to at() function (#379 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/379>)
  * Contributors: Dominic Reber, Felix Exner, Pablo David Aranda Rodriguez, URJala

 -- Felix Exner <feex@universal-robots.com>  Mon, 13 Oct 2025 00:00:00 -0000

ros-one-ur-client-library (2.3.0-0jammy) jammy; urgency=high

  * Install endian header on Windows and Apple only (#372 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/372>)
  * Add support for UR8 LONG (#375 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/375>)
  * Change ubuntu manpage link from bionic to noble (#374 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/374>)
  * Bump actions/setup-python from 5 to 6 (#373 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/373>)
  * Add possibility to register multiple callbacks to ReverseInterface and TrajectoryPointInterface (#359 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/359>)
  * Contributors: Felix Exner, dependabot[bot]

 -- Felix Exner <feex@universal-robots.com>  Mon, 15 Sep 2025 00:00:00 -0000

ros-one-ur-client-library (2.2.0-0jammy) jammy; urgency=high

  * Remove print statement when executing optimovel primitives (#365 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/365>)
  * Remove SDK version mapping (#355 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/355>)
  * Support optimove motions in InstructionExecutor (#354 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/354>)
  * Initialize ReverseInterface with a config struct (#351 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/351>)
  * Join thread_move instead of killing it (#349 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/349>)
  * Fix external_control urcapx version to 0.1.0 for PolyScope 10.7.0 (#350 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/350>)
  * Contributors: Felix Exner

 -- Felix Exner <feex@universal-robots.com>  Mon, 21 Jul 2025 00:00:00 -0000

ros-one-ur-client-library (2.1.0-0jammy) jammy; urgency=high

  * Minimal support for building on macOS (#341 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/341>)
  * Install endian.h and add that to the target include directories on Windows and MacOS (#345 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/345>)
  * Add ScriptReader for script template parsing (#343 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/343>)
  * Add more tests for VersionInformation (#344 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/344>)
  * Fix driver branch for Jazzy downstream build (#339 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/339>)
  * Stop control, when UrDriver object is destroyed (#338 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/338>)
  * Add new robot types to URSim startup script (#331 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/331>)
  * Fix robot message type POPUP (#335 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/335>)
  * Disable checking links for two broken ones (#333 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/333>)
  * readme: load ROSin imgs from press_kit repository (#334 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/334>)
  * Added configuration data to packages parsed from the primary interface (#327 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/327>)
  * Correct message sum in test_tool_contact (#324 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/324>)


=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/one/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

# Solve shlibdeps errors in REP136 packages that use GNUInstallDirs:
export DEB_HOST_MULTIARCH := $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_configure -- \
		-DFETCHCONTENT_FULLY_DISCONNECTED=OFF \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/one" \
		-DCMAKE_PREFIX_PATH="/opt/ros/one" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-one-ur-client-library//opt/ros/one/lib/:$(CURDIR)/debian/ros-one-ur-client-library//opt/ros/one/lib/${DEB_HOST_MULTIARCH}

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/one/setup.sh" ]; then . "/opt/ros/one/setup.sh"; fi && \
	dh_auto_install

## ros-one-ur-client-library 2.5.0-2noble.20251029.2032

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14.0)
project(ur_client_library)

if(NOT CMAKE_CONFIGURATION_TYPES AND NOT CMAKE_BUILD_TYPE)
  message("${PROJECT_NAME}: You did not request a specific build type: selecting 'RelWithDebInfo'.")
  set(CMAKE_BUILD_TYPE RelWithDebInfo)
endif()

option(WITH_ASAN "Compile with address sanitizer support" OFF)
option(BUILD_SHARED_LIBS "Build using shared libraries" ON)

if(MSVC)
set(BUILD_SHARED_LIBS OFF)
endif()


add_library(urcl
    src/comm/tcp_socket.cpp
    src/comm/tcp_server.cpp
    src/control/motion_primitives.cpp
    src/control/reverse_interface.cpp
    src/control/script_reader.cpp
    src/control/script_sender.cpp
    src/control/trajectory_point_interface.cpp
    src/control/script_command_interface.cpp
    src/primary/primary_package.cpp
    src/primary/primary_client.cpp
    src/primary/robot_message.cpp
    src/primary/robot_state.cpp
    src/primary/robot_message/version_message.cpp
    src/primary/robot_message/error_code_message.cpp
    src/primary/robot_state/kinematics_info.cpp
    src/primary/robot_state/robot_mode_data.cpp
    src/primary/robot_state/configuration_data.cpp
    src/rtde/control_package_pause.cpp
    src/rtde/control_package_setup_inputs.cpp
    src/rtde/control_package_setup_outputs.cpp
    src/rtde/control_package_start.cpp
    src/rtde/data_package.cpp
    src/rtde/get_urcontrol_version.cpp
    src/rtde/request_protocol_version.cpp
    src/rtde/rtde_package.cpp
    src/rtde/text_message.cpp
    src/rtde/rtde_client.cpp
    src/ur/ur_driver.cpp
    src/ur/calibration_checker.cpp
    src/ur/dashboard_client.cpp
    src/ur/dashboard_client_implementation_g5.cpp
    src/ur/dashboard_client_implementation_x.cpp
    src/ur/instruction_executor.cpp
    src/ur/tool_communication.cpp
    src/ur/robot_receive_timeout.cpp
    src/ur/version_information.cpp
    src/rtde/rtde_writer.cpp
    src/default_log_handler.cpp
    src/example_robot_wrapper.cpp
    src/log.cpp
    src/helpers.cpp
)
add_library(ur_client_library::urcl ALIAS urcl)
target_compile_features(urcl PUBLIC cxx_std_17)

if(MSVC)
  target_link_libraries(urcl ws2_32)
  target_include_directories(urcl PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/endian>
    $<INSTALL_INTERFACE:include/${PROJECT_NAME}/3rdparty>
  )
else()
  if(APPLE)
    target_include_directories(urcl PUBLIC
      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/endian>
      $<INSTALL_INTERFACE:include/${PROJECT_NAME}/3rdparty>
    )
  endif()
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -pedantic")
  target_compile_options(urcl PRIVATE -Wall -Wextra -Wno-unused-parameter)

  if(WITH_ASAN)
    target_compile_options(urcl PUBLIC -fsanitize=address)
    target_link_options(urcl PUBLIC -fsanitize=address)
  endif()
endif()

target_include_directories(urcl PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)
target_include_directories(urcl PRIVATE
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/3rdparty>
)

find_package(Threads REQUIRED)
if(THREADS_HAVE_PTHREAD_ARG)
  target_compile_options(urcl PUBLIC "-pthread")
endif()
if(CMAKE_THREAD_LIBS_INIT)
  target_link_libraries(urcl PUBLIC "${CMAKE_THREAD_LIBS_INIT}")
endif()

##
## Build testing if enabled by option
##
if (BUILDING_TESTS)
  enable_testing()
  add_subdirectory(tests)
else()
  message(STATUS "Building tests disabled.")
endif()


add_subdirectory(examples)

include(GNUInstallDirs)
install(TARGETS urcl EXPORT urcl_targets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
)
install(DIRECTORY include/ DESTINATION include)
if(MSVC OR APPLE)
  install(DIRECTORY 3rdparty/endian/ DESTINATION include/${PROJECT_NAME}/3rdparty
    FILES_MATCHING PATTERN "*.h"
  )
endif()

install(EXPORT urcl_targets
  DESTINATION lib/cmake/ur_client_library
  FILE urclTargets.cmake
  NAMESPACE ur_client_library::)

if(CATKIN_PACKAGE_BIN_DESTINATION)
  install(PROGRAMS scripts/start_ursim.sh
    DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
  )
else()
  install(PROGRAMS scripts/start_ursim.sh
    DESTINATION lib/${PROJECT_NAME}
  )
endif()

include(CMakePackageConfigHelpers)
write_basic_package_version_file(${CMAKE_CURRENT_BINARY_DIR}/ur_client_libraryConfigVersion.cmake VERSION 0.0.3
  COMPATIBILITY SameMajorVersion)
install(FILES ur_client_libraryConfig.cmake
  DESTINATION lib/cmake/ur_client_library)

# Install package.xml file so this package can be processed by ROS toolings
# See REP 136 for details
# Installing this in non-ROS environments won't have any effect, but it won't harm, either.
install(FILES package.xml DESTINATION share/${PROJECT_NAME})

#### Begin import ####
# Imported from ros-industrial/ros_industrial_cmake_boilerplate
# https://github.com/ros-industrial/ros_industrial_cmake_boilerplate/blob/59b86df662/ros_industrial_cmake_boilerplate/cmake/cmake_tools.cmake
# Copyright (C) 2018 by George Cave - gcave@stablecoder.ca
# Copyright (c) 2020, Southwest Research Institute
# Licensed under Apache-2.0 license

# Allows Colcon to find non-Ament packages when using workspace underlays
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/ament_index/resource_index/packages/${PROJECT_NAME} "")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/ament_index/resource_index/packages/${PROJECT_NAME} DESTINATION share/ament_index/resource_index/packages)
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/${PROJECT_NAME}/hook/ament_prefix_path.dsv "prepend-non-duplicate;AMENT_PREFIX_PATH;")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/${PROJECT_NAME}/hook/ament_prefix_path.dsv DESTINATION share/${PROJECT_NAME}/hook)
file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/share/${PROJECT_NAME}/hook/ros_package_path.dsv "prepend-non-duplicate;ROS_PACKAGE_PATH;")
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/share/${PROJECT_NAME}/hook/ros_package_path.dsv DESTINATION share/${PROJECT_NAME}/hook)
#### End iport ####

install(DIRECTORY resources DESTINATION share/${PROJECT_NAME})

=== examples/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.14.0)
project(ur_driver_examples)

# find_package(ur_client_library REQUIRED)


add_executable(driver_example
  full_driver.cpp)
target_link_libraries(driver_example ur_client_library::urcl)

add_executable(primary_pipeline_example
  primary_pipeline.cpp)
target_link_libraries(primary_pipeline_example ur_client_library::urcl)

add_executable(primary_pipeline_calibration_example
  primary_pipeline_calibration.cpp)
target_link_libraries(primary_pipeline_calibration_example ur_client_library::urcl)

add_executable(rtde_client_example
  rtde_client.cpp)
target_link_libraries(rtde_client_example ur_client_library::urcl)

add_executable(dashboard_example
  dashboard_example.cpp)
target_link_libraries(dashboard_example ur_client_library::urcl)

add_executable(spline_example
spline_example.cpp)
target_link_libraries(spline_example ur_client_library::urcl)

add_executable(tool_contact_example
tool_contact_example.cpp)
target_link_libraries(tool_contact_example ur_client_library::urcl)

add_executable(freedrive_example
freedrive_example.cpp)
target_link_libraries(freedrive_example ur_client_library::urcl)

add_executable(force_mode_example
force_mode_example.cpp)
target_link_libraries(force_mode_example ur_client_library::urcl)

add_executable(script_sender_example
script_sender.cpp)
target_link_libraries(script_sender_example ur_client_library::urcl)

add_executable(script_command_interface_example
script_command_interface.cpp)
target_link_libraries(script_command_interface_example ur_client_library::urcl)

add_executable(direct_torque_control_example
  direct_torque_control.cpp)
target_link_libraries(direct_torque_control_example ur_client_library::urcl)

add_executable(trajectory_point_interface_example
trajectory_point_interface.cpp)
target_link_libraries(trajectory_point_interface_example ur_client_library::urcl)

add_executable(instruction_executor
instruction_executor.cpp)
target_link_libraries(instruction_executor ur_client_library::urcl)

add_executable(external_fts_through_rtde
external_fts_through_rtde.cpp)
target_link_libraries(external_fts_through_rtde ur_client_library::urcl)

=== debian/changelog ===
ros-one-ur-client-library (2.5.0-2noble.20251029.2032) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Felix Exner <feex@universal-robots.com>  Wed, 29 Oct 2025 20:32:04 +0000

ros-one-ur-client-library (2.5.0-0noble) noble; urgency=high

  * Polyscopex dashboard client (#392 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/392>)
  * Use enable_external_ft_sensor on old software versions (#395 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/395>)
  * Rtde external ft (#388 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/388>)
  * Fixed auto reconnection to the RTDE server. (#384 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/384>)
  * Refactor Rtde client test (#389 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/389>)
  * Add release.yml for auto-generated changelogs (#391 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/391>)
  * Allow an empty input recipe to the RTDE client (#318 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/318>)
  * Contributors: Felix Exner, Mads Holm Peters, URJala

 -- Felix Exner <feex@universal-robots.com>  Fri, 24 Oct 2025 00:00:00 -0000

ros-one-ur-client-library (2.4.0-0noble) noble; urgency=high

  * UR18 support (#387 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/387>)
  * Remove output_bit_register_0...63 and input_bit_register_0..63 from RTDE list (#385 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/385>)
  * Set force mode parameters from config (#383 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/383>)
  * Direct torque control (#381 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/381>)
  * Update RTDE list to include new fields (#380 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/380>)
  * Add const qualifier to get functions and changed map value retrieval to at() function (#379 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/379>)
  * Contributors: Dominic Reber, Felix Exner, Pablo David Aranda Rodriguez, URJala

 -- Felix Exner <feex@universal-robots.com>  Mon, 13 Oct 2025 00:00:00 -0000

ros-one-ur-client-library (2.3.0-0noble) noble; urgency=high

  * Install endian header on Windows and Apple only (#372 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/372>)
  * Add support for UR8 LONG (#375 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/375>)
  * Change ubuntu manpage link from bionic to noble (#374 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/374>)
  * Bump actions/setup-python from 5 to 6 (#373 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/373>)
  * Add possibility to register multiple callbacks to ReverseInterface and TrajectoryPointInterface (#359 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/359>)
  * Contributors: Felix Exner, dependabot[bot]

 -- Felix Exner <feex@universal-robots.com>  Mon, 15 Sep 2025 00:00:00 -0000

ros-one-ur-client-library (2.2.0-0noble) noble; urgency=high

  * Remove print statement when executing optimovel primitives (#365 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/365>)
  * Remove SDK version mapping (#355 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/355>)
  * Support optimove motions in InstructionExecutor (#354 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/354>)
  * Initialize ReverseInterface with a config struct (#351 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/351>)
  * Join thread_move instead of killing it (#349 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/349>)
  * Fix external_control urcapx version to 0.1.0 for PolyScope 10.7.0 (#350 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/350>)
  * Contributors: Felix Exner

 -- Felix Exner <feex@universal-robots.com>  Mon, 21 Jul 2025 00:00:00 -0000

ros-one-ur-client-library (2.1.0-0noble) noble; urgency=high

  * Minimal support for building on macOS (#341 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/341>)
  * Install endian.h and add that to the target include directories on Windows and MacOS (#345 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/345>)
  * Add ScriptReader for script template parsing (#343 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/343>)
  * Add more tests for VersionInformation (#344 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/344>)
  * Fix driver branch for Jazzy downstream build (#339 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/339>)
  * Stop control, when UrDriver object is destroyed (#338 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/338>)
  * Add new robot types to URSim startup script (#331 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/331>)
  * Fix robot message type POPUP (#335 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/335>)
  * Disable checking links for two broken ones (#333 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/333>)
  * readme: load ROSin imgs from press_kit repository (#334 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/334>)
  * Added configuration data to packages parsed from the primary interface (#327 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/327>)
  * Correct message sum in test_tool_contact (#324 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/324>)


=== debian/control ===
Source: ros-one-ur-client-library
Section: misc
Priority: optional
Maintainer: Felix Exner <feex@universal-robots.com>
Build-Depends: debhelper (>= 9.0.0), cmake
Homepage: http://wiki.ros.org/ur_client_library
Standards-Version: 3.9.2

Package: ros-one-ur-client-library
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-one-catkin
Description: Standalone C++ library for accessing Universal Robots interfaces.
 This has been forked off the ur_robot_driver.

## ros-one-ur-client-library 2.6.1-2jammy.20251212.2031

=== debian/changelog ===
ros-one-ur-client-library (2.6.1-2jammy.20251212.2031) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Felix Exner <feex@universal-robots.com>  Fri, 12 Dec 2025 20:31:08 +0000

ros-one-ur-client-library (2.6.1-0jammy) jammy; urgency=high

  * Ignore lists.apple link in link check (#411 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/411>)
  * Bump actions/checkout from 5 to 6 (#412 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/412>)
  * [Doc] Remove beta statement for External Control URCapX (#407 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/407>)
  * Updated version check, as 5.23 has been released
  * Initialize dashboard client for PolyScopeX version 10.11.0 and above (#409 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/409>)
  * Explicitly list PolyScope X compatibility (#402 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/402>)
  * Contributors: Felix Exner, Mads Holm Peters, dependabot[bot]

 -- Felix Exner <feex@universal-robots.com>  Mon, 01 Dec 2025 00:00:00 -0000

ros-one-ur-client-library (2.6.0-0jammy) jammy; urgency=high

  * RTDEClient sendStart handle missed confirmation (#403 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/403>)
  * Add enum value for 3PE input active to UrRtdeSafetyStatusBits (#401 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/401>)
  * Save polyscope folder in local filesystem (#399 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/399>)
  * Succeed power on command on PolyScope 5 when robot is running (#397 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/397>)
  * Bump actions/upload-artifact from 4 to 5 (#398 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/398>)
  * Contributors: Andrew C. Morrow, Felix Exner, dependabot[bot]

 -- Felix Exner <feex@universal-robots.com>  Mon, 10 Nov 2025 00:00:00 -0000

## ros-one-ur-client-library 2.6.1-2noble.20251212.2032

=== debian/changelog ===
ros-one-ur-client-library (2.6.1-2noble.20251212.2032) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Felix Exner <feex@universal-robots.com>  Fri, 12 Dec 2025 20:32:00 +0000

ros-one-ur-client-library (2.6.1-0noble) noble; urgency=high

  * Ignore lists.apple link in link check (#411 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/411>)
  * Bump actions/checkout from 5 to 6 (#412 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/412>)
  * [Doc] Remove beta statement for External Control URCapX (#407 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/407>)
  * Updated version check, as 5.23 has been released
  * Initialize dashboard client for PolyScopeX version 10.11.0 and above (#409 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/409>)
  * Explicitly list PolyScope X compatibility (#402 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/402>)
  * Contributors: Felix Exner, Mads Holm Peters, dependabot[bot]

 -- Felix Exner <feex@universal-robots.com>  Mon, 01 Dec 2025 00:00:00 -0000

ros-one-ur-client-library (2.6.0-0noble) noble; urgency=high

  * RTDEClient sendStart handle missed confirmation (#403 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/403>)
  * Add enum value for 3PE input active to UrRtdeSafetyStatusBits (#401 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/401>)
  * Save polyscope folder in local filesystem (#399 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/399>)
  * Succeed power on command on PolyScope 5 when robot is running (#397 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/397>)
  * Bump actions/upload-artifact from 4 to 5 (#398 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/398>)
  * Contributors: Andrew C. Morrow, Felix Exner, dependabot[bot]

 -- Felix Exner <feex@universal-robots.com>  Mon, 10 Nov 2025 00:00:00 -0000

## ros-one-ur-client-library 2.6.1-6jammy.20260119.2035

=== debian/changelog ===
ros-one-ur-client-library (2.6.1-6jammy.20260119.2035) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Felix Exner <feex@universal-robots.com>  Mon, 19 Jan 2026 20:35:00 +0000

## ros-one-ur-client-library 2.6.1-6noble.20260119.2033

=== debian/changelog ===
ros-one-ur-client-library (2.6.1-6noble.20260119.2033) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Felix Exner <feex@universal-robots.com>  Mon, 19 Jan 2026 20:33:12 +0000

## ros-one-ur-client-library 2.6.1-14jammy.20260209.2047

=== debian/changelog ===
ros-one-ur-client-library (2.6.1-14jammy.20260209.2047) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Felix Exner <feex@universal-robots.com>  Mon, 09 Feb 2026 20:47:36 +0000

## ros-one-ur-client-library 2.6.1-14noble.20260209.2047

=== CMakeLists.txt ===
--- 
+++ 
@@ -26,9 +26,12 @@
     src/primary/primary_package.cpp
     src/primary/primary_client.cpp
     src/primary/robot_message.cpp
+    src/primary/robot_message/error_code_message.cpp
+    src/primary/robot_message/key_message.cpp
+    src/primary/robot_message/runtime_exception_message.cpp
+    src/primary/robot_message/text_message.cpp
+    src/primary/robot_message/version_message.cpp
     src/primary/robot_state.cpp
-    src/primary/robot_message/version_message.cpp
-    src/primary/robot_message/error_code_message.cpp
     src/primary/robot_state/kinematics_info.cpp
     src/primary/robot_state/robot_mode_data.cpp
     src/primary/robot_state/configuration_data.cpp

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -90,20 +90,10 @@
                   TEST_SUFFIX _headless
   )
 
-  # PrimaryClient tests
-  add_executable(primary_client_test_urcap test_primary_client.cpp)
-  target_link_libraries(primary_client_test_urcap PRIVATE ur_client_library::urcl GTest::gtest_main)
-  gtest_add_tests(TARGET primary_client_test_urcap
-                  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
-                  EXTRA_ARGS --headless false
-                  TEST_SUFFIX _urcap
-  )
   add_executable(primary_client_test_headless test_primary_client.cpp)
   target_link_libraries(primary_client_test_headless PRIVATE ur_client_library::urcl GTest::gtest_main)
   gtest_add_tests(TARGET primary_client_test_headless
                   WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
-                  EXTRA_ARGS --headless true
-                  TEST_SUFFIX _headless
   )
 
   add_executable(ur_driver_deprecated_constructor_test test_deprecated_ur_driver_construction.cpp)

=== debian/changelog ===
ros-one-ur-client-library (2.6.1-14noble.20260209.2047) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Felix Exner <feex@universal-robots.com>  Mon, 09 Feb 2026 20:47:49 +0000

## ros-one-ur-client-library 2.7.0-4jammy.20260302.2046

=== debian/changelog ===
ros-one-ur-client-library (2.7.0-4jammy.20260302.2046) UNRELEASED; urgency=medium

  * Append timestamp when binarydeb was built.

 -- Felix Exner <feex@universal-robots.com>  Mon, 02 Mar 2026 20:46:54 +0000

ros-one-ur-client-library (2.7.0-0jammy) jammy; urgency=high

  * Add more RobotAPI commands to PolyScope X Dashboard Client (#435 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/435>)
  * [RTDE client] Test reconnect (#433 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/433>)
  * [TCPServer] Close all filedescriptors on shutdown (#432 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/432>)
  * [primary interface] More robot messages (#429 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/429>)
  * Fix instruction executor idle (#424 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/424>)
  * [primary interface] Fix parsing of primary messages (#426 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/426>)
  * [primary interface] Add KeyMessage parsing (#428 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/428>)
  * Add test for VersionMessage (#427 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/427>)
  * Add two new RTDE fields (#420 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/420>)
    Add fields
    - target_gravity
    - target_base_acceleration
  * Allow updating robot gravity (#415 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/415>)
  * Do not disconnect dashboard_client on read timeout (#414 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/414>)
  * Added support for std::vector strings in UrDriver (#408 <https://github.com/UniversalRobots/Universal_Robots_Client_Library/issues/408>)
  * Contributors: AdamPettinger, Felix Exner, Pablo David Aranda Rodriguez, dependabot[bot]

 -- Felix Exner <feex@universal-robots.com>  Wed, 18 Feb 2026 00:00:00 -0000
